/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code shows how to draw a string in a drawing area.
***************************************************************/

/* draw_string.c */

#include <Xm/Xm.h>
#include <Xm/DrawingA.h>

XtAppContext context;

GC gc;
Widget drawing_area;
Widget toplevel;

void setup_gc()
/* set up the graphics context. */
{
    int foreground,background;
    XGCValues vals;
    Arg al[10];
    int ac;
    XFontStruct *font=NULL;
    char *namestring=NULL;

    /* load the font */
    namestring = "*times*-24-*";
    font=XLoadQueryFont(XtDisplay(drawing_area),namestring);

     /* get the current fg and bg colors. */
    ac=0;
    XtSetArg(al[ac], XmNforeground, &foreground); ac++;
    XtSetArg(al[ac], XmNbackground, &background); ac++;
    XtGetValues(drawing_area, al, ac);

    /* create the gc. */
    vals.foreground = foreground;
    vals.background = background;
    vals.font=font->fid; /* The XFontStruct contains a field named 
                            "fid" of type Font, as expect by the GC. */
    gc = XtGetGC(drawing_area, GCForeground | GCBackground | GCFont,
        &vals);
}

void exposureCB(w,client_data,call_data)
    Widget w; 
    XtPointer client_data; 
    XtPointer call_data;
/* called whenever drawing area is exposed. */
{
    printf("exposure event generated\n");
    XDrawString(XtDisplay(drawing_area), XtWindow(drawing_area), 
        gc, 100, 100, "hello", 5);
}

void main(argc,argv)
    int argc;
    char *argv[];
{
    Arg al[10];
    int ac;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,
        NULL,NULL,0);

    /* set window size. */
    ac=0;
    XtSetArg(al[ac],XmNheight,200); ac++;
    XtSetArg(al[ac],XmNwidth,200); ac++;
    XtSetValues(toplevel,al,ac);

    /* create a drawing area widget. */
    ac=0;
    drawing_area=XmCreateDrawingArea(toplevel,"drawing_area",al,ac);
    XtManageChild(drawing_area);    
    XtAddCallback(drawing_area,XmNexposeCallback,exposureCB,NULL);

    setup_gc();

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
