/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code shows how to change the font used by a label widget.
***************************************************************/

/* font.c */

#include <Xm/Xm.h>
#include <Xm/Label.h>

XtAppContext context;
XmStringCharSet char_set=XmSTRING_DEFAULT_CHARSET;

Widget toplevel, label;

main(argc,argv)
  int argc; 
  char *argv[];
{
  Arg al[10];
  int ac;
  XFontStruct *font=NULL;
  XmFontList fontlist=NULL;
  char *namestring=NULL;


  /* create the toplevel shell */
  toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,
        NULL,NULL,0);

  /* create label widget */
  ac=0;
  XtSetArg(al[ac],XmNlabelString, 
    XmStringCreateLtoR("Hello World", char_set)); ac++;
  label=XmCreateLabel(toplevel,"label",al,ac);
  XtManageChild(label);

  /* Set fontList resource in the label widget. */
  namestring="*times*24*"; /* you may need to change this. */
  font=XLoadQueryFont(XtDisplay(label),namestring);
  fontlist=XmFontListCreate(font,char_set);   
  ac=0;
  XtSetArg(al[ac],XmNfontList,fontlist); ac++;
  XtSetValues(label,al,ac);

  XtRealizeWidget(toplevel); 
  XtAppMainLoop(context); 
}
