/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code shows how to create a scale widget and use its 
valueChanged callback.
***************************************************************/

/* scale_callback.c */

#include <Xm/Xm.h>
#include <Xm/Scale.h>

XtAppContext context;
XmStringCharSet char_set=XmSTRING_DEFAULT_CHARSET;

Widget toplevel, scale;

void handle_scale(w,client_data,call_data)
    Widget w;
    caddr_t client_data;
    XmScaleCallbackStruct *call_data;
/* handles the scale widget's callbacks. */
{
    Arg al[10];
    int ac;
    int value;

    ac=0;
    XtSetArg(al[ac],XmNvalue,&value); ac++;
    XtGetValues(w,al,ac);
    printf("value = %d\n",value);
}

void main(argc,argv) 
    int argc; 
    char *argv[];
{
    Arg al[10];
    int ac;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,NULL,NULL,0);

    /* create the scale widget */
    ac=0;   
    XtSetArg(al[ac],XmNtitleString, 
        XmStringCreate("Slide Me",char_set)); ac++;
    XtSetArg(al[ac],XmNorientation,XmHORIZONTAL); ac++;
    scale=XmCreateScale(toplevel,"scale",al,ac);
    XtManageChild(scale);
    XtAddCallback(scale,XmNvalueChangedCallback,handle_scale,NULL);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
